;*********************************************************************
;*                  ROM dump program for PB-1000/C                   *
;*               (C)2009 Miyura (miyura321@ybb.ne.jp)                *
;*********************************************************************

PB1000:	EQU	1			;PB-1000
PB1000C:EQU	2			;PB-1000C
MODEL:	EQU	PB1000

PBF:	EQU	1			;1:Mɉ]\
;
;	system call
;
#if MODEL=PB1000
BRKJP:	EQU	&H9230			;BREAK̔ѐɃWv
PRLB1:	EQU	&H9669			;\
B2DEC:	EQU	&HB0EE			;$3,$4̓e10iɕϊIZȍ~Ɋi[
RSOPN:	EQU	&HBE11			;RS232C OPEN
RSCLO:	EQU	&HBE5D			;RS232C CLOSE
PRTRS:	EQU	&HBEFF			;RS232C M
CASC1:	EQU	&HF1EF			;$16̉ʃfWbgASCIIR[hɕϊ
#else
BRKJP:	EQU	&H9300			;BREAK̔ѐɃWv
PRLB1:	EQU	&HABA6			;\
B2DEC:	EQU	&HB214			;$3,$4̓e10iɕϊIZȍ~Ɋi[
RSOPN:	EQU	&HBFA4			;RS232C OPEN
RSCLO:	EQU	&HBFF0			;RS232C CLOSE
PRTRS:	EQU	&HC092			;RS232C M
#endif
;
;	work area
;
EDCSR:	EQU	&H68C8			;J[\ʒu
RSFG:	EQU	&H6C00			;RS-232CftHgl


	ORG	&H7000
	START	START
;
;	display message
;
START:	LDW	$0,EDCSR		;J[\ʒu4sڐ擪ɐݒ
	ST	&H60,($0)		;
	PRE	IX,MSG01		;"saving pbf."\
	CAL	PRLB1			;
;
;	open RS232C
;
	LD	$0,$30			;OPEN[hݒ(M)
	PRE	IX,RSFG			;RS232Cp[^ݒ
	LD	$11,(IX+$31)		;
	LD	$13,&H02		;XON/XOFFL
	CAL	RSOPN
;
;	set ROM dump area
;
	LDW	$19,&H8000		;$19,20 = JnAhX
	LDW	$21,&HFFFF		;$21,22 = IAhX
	LDW	$26,$19			;$26,27 = sAhX
;
;	send file name
;
	LD	$13,7			;ݒ
	CAL	XSNDM			;LN^̑M
	CAL	XCOMMA			;R}M
;
;	send file address
;
	LDW	$3,$19			;JnAhX10iϊđM
	CAL	XDEC			;
	CAL	XCOMMA			;R}M
	LDW	$3,$21			;IAhX10iϊđM
	CAL	XDEC			;
	CAL	XSUM			;sAhX10iϊđM
;
;	send binary data
;
	LD	$18,$31

#if PBF
	LD	$21,&H83		;o̓[h
	LDW	$22,&H03A2		;Ww
	LDW	$24,&HE060		;R[hݒ
#endif

XBIN:	LD	$10,120			;1sf[^Zbg
	XRW	$26,$26			;`FbNT

XBIN1:	PST	UA,$31			;bank 0
	LD	$17,($19)		;1oCgǂݍ
	PST	UA,&H50			;bank 1

	ADW	$26,$17			;`FbNTZ

#if PBF
	ANC	$19,&H3F		;16oCgMɕ\
	JR	LNZ,XBIN2		;

	PPO	&HC7			;LCDR}hWX^w肷 
	STLM	$21,3			;(R}hݒ) 
	PPO	&HC6			;LCDf[^ݎw
	STL	$24			;1\

	XR	$24,$25			;60H->80H->70H->90H->60H
	XR	$25,&H10		;
#endif

XBIN2:	LD	$16,$17			;
	DID	$16			;ʌASCIIϊđM
	CAL	XASC			;

	LD	$16,$17			;ʌASCIIϊđM
	CAL	XASC			;

	ADW	$19,$30			;|C^ + 1
	JR	Z,XCLOSE		;I`FbN

	SB	$10,$30			;1sI`FbN
	JR	NZ,XBIN1		;

	CAL	XSUM			;`FbNTf[^M
	JR	XBIN
;
;	termination process
;
XCLOSE:	CAL	XSUM			;`FbNTf[^M
	CAL	RSCLO			;RS232CN[Y
	JP	BRKJP			;VXeɖ߂
;
;	send decimal data
;
XDEC:	PRE	IZ,FNAME		;FNAMEobt@Ɏgp
	LD	$13,$31			;JE^Zbg
	CAL	B2DEC			;$3,$4̓e10iɕϊ
	SBC	$13,$31			;
	JR	NZ,XSNDM		;Ml0̏ꍇ
	LD	$16,"0",XSEND		;"0"M
;
;	send multi byte data
;
XSNDM:	PRE	IX,FNAME		;FNAMEobt@Ɏgp
XSND01:	LDI	$16,(IX+$31)		;1o
	CAL	PRTRS			;$16̃f[^RS232CőM
	SB	$13,$30			;
	JR	NZ,XSND01		;
	RTN
;
;	send check sum data
;
XSUM:	CAL	XCOMMA			;R}o
	LDW	$3,$26			;`FbNTf[^(܂͎sAhX)
	CAL	XDEC			;10iϊđM

	LD	$16,&H0D		;0Dho
	CAL	PRTRS
	LD	$16,&H0A,XSEND		;0Aho
;
;	send comma
;
XCOMMA:	LD	$16,",",XSEND
;
;	send ascii data
;
XASC:
#if MODEL=PB1000
	CAL	CASC1
#else
	AN	$16,&H0F		;digitNA
	OR	$16,&H30		;+'0'
	SBC	$16,&H3A		;$16'1'`'9'ȂXSEND
	JR	C,XSEND
	AD	$16,&H07		;$16='A'`'F'
#endif
XSEND:	JP	PRTRS

FNAME:	DB	"ROM.BIN"		;output file name
MSG01:	DB	11,"saving pbf."	;message data
