;******************************************************************
;*           PBF to binary data converter for PB-1000/C           *
;*         (C)2007 Miyura (miyura321@ybb.ne.jp) and Blue          *
;******************************************************************

PB1000:	EQU	1			;PB-1000
PB1000C:EQU	2			;PB-1000C
MODEL:	EQU	PB1000

PBF:	EQU	1			;1:Mɉ]\
FLNMAX:	EQU	8			;t@C̍ő啶
EXPMAX:	EQU	3			;gq̍ő啶
;
;	system call
;
CHEX1:	EQU	&H0160			;ASCII-->BINϊ

#if MODEL=PB1000
PRLB1:	EQU	&H9669			;\
OMERR:	EQU	&HABBD			;OM Error
SNERR:	EQU	&HABC0			;SN Error
TMERR:	EQU	&HAC04			;TM Error

RSOPN:	EQU	&HBE11			;RS232C OPEN
RSCLO:	EQU	&HBE5D			;RS232C CLOSE
RSGET:	EQU	&HBE9C			;RS232C 1oCgM

SNDWK:	EQU	&HD33E			;IZAhX11byteWORK1֓]
FNSCH:	EQU	&HE818			;t@C
KILL:	EQU	&HE842			;t@C폜

MENU:	EQU	&HECA6			;MENU[h

#else
PRLB1:	EQU	&HABA6			;\
OMERR:	EQU	&HAD07			;OM Error
SNERR:	EQU	&HAD0F			;SN Error
TMERR:	EQU	&HAD53			;TM Error

RSOPN:	EQU	&HBFA4			;RS232C OPEN
RSCLO:	EQU	&HBFF0			;RS232C CLOSE
RSGET:	EQU	&HC02F			;RS232C 1oCgM

SNDWK:	EQU	&HD4DC			;IZAhX11byteWORK1֓]
FNSCH:	EQU	&HEA0C			;t@C
KILL:	EQU	&HEA36			;t@C폜

MENU:	EQU	&HEFBB			;MENU[h
#endif
;
;	work area
;
EDCSR:	EQU	&H68C8			;J[\ʒu
WORK1:	EQU	&H68F4			;BASIC WORKobt@
MEMEN:	EQU	&H6945			;t[GA擪|C^
DATDIR: EQU	&H6947			;f[^DIR擪|C^
RSFG:	EQU	&H6C00			;RS-232CftHgl
NOWFL:	EQU	&H6F54			;ݎgpĂt@C̃AhX


	ORG	&H7000
	START	START
;
;	display message
;
START:	LDW	$0,EDCSR		;J[\ʒu4sڐ擪ɐݒ
	ST	&H60,($0)		;
	PRE	IX,MSG01		;"loading pbf."\
	CAL	PRLB1			;
;
;	open RS232C
;
	LD	$0,&H02			;OPEN[hݒ(M)
	PRE	IX,RSFG			;RS232Cp[^ݒ
	LD	$11,(IX+$31)		;
	LD	$13,$0			;XON/XOFFL
	CAL	RSOPN
;
;	get file name
;
GETFLN:	PRE	IX,DIRBF1		;t@Ci[擪AhX
	LD	$10,$31			;JE^[NA
GETFL1:	CAL	XGET			;1M($0)
	JR	Z,FKILL			;J}/CRMŏI
	SBC	$0,"."			;sIhogq擾
	JR	Z,GETEXP		;
	SBC	$10,FLNMAX		;ő啶𒴂obt@ɏ܂Ȃ
	JR	NC,GETFL1		;
	STI	$0,(IX+$31)		;fBNgobt@ւ̏
	AD	$10,$30,GETFL1		;JE^[ +1
;
;	get extension name
;
GETEXP:	PRE	IX,DIRBF2		;gqi[擪AhX
	LD	$10,$31			;JE^[NA
GETEX1:	CAL	XGET			;1M($0)
	JR	Z,FKILL			;J}/CRMŏI
	SBC	$10,EXPMAX		;ő啶𒴂obt@ɏ܂Ȃ
	JR	NC,GETEX1		;
	STI	$0,(IX+$31)		;fBNgobt@ւ̏
	AD	$10,$30,GETEX1		;JE^[ +1
;
;	delete existing file
;
FKILL:	PRE	IZ,DIRBF1		;Mt@CWORK1ɓ]
	CAL	SNDWK			;
	LD	$4,&H0D			;oCit@Cݒ
	CAL	FNSCH			;t@C
	CAL	NC,KILL			;Õt@C΍폜
;
;	get address data
;
GETADR:	CAL	GETDEC			;擪AhX擾
	LDW	$20,$10			;
	CAL	GETDEC			;IAhX擾
	LDW	$22,$10			;
	ADW	$22,$30			;IAhX + 1
	CAL	GETDEC			;sAhX擾
	LDW	$24,$10			;

	PRE	IX,DIRBF3		;fBNgobt@ւ̏
	STM	$20,(IX+$31),6		;
	LDW	$0,$22			;t@CTCYvZ
	SBW	$0,$20			;

	PRE	IX,MEMEN		;t[GA擪|C^
	LDW	$20,(IX+$31)		;t@Ci[擪AhX
	LDM	$22,(IX+$31),4		;
	ADW	$22,$0			;t@Ci[IAhX
	JP	C,OMERR
	LDW	$26,$22
	LDW	$0,&H0020		;
	SBW	$24,$0			;(DATDIR)-32$24,25

	SBCW	$22,$24			;t[GA`FbN
OMERROR:JP	NC,OMERR		;

	ADW	$22,$30			;IAhX + 1
	PRE	IX,DIRBF0		;fBNgobt@ւ̏
	STM	$20,(IX+$31),4		;
;
;	get pbf data
;
#if PBF
	LD	$12,&H83		;o̓[h
	LDW	$13,&H03AE		;Ww
	LDW	$28,&HE060		;R[hݒ
#endif

GETPBF:	XRM	$17,$17,3		;`FbNT
GETPBL:	SBCW	$20,$24			;t[GA`FbN
	JR	NC,OMERROR

#if PBF
	ANC	$20,&H3F		;16oCgMɕ\
	JR	LNZ,GETPB2		;

	PPO	&HC7			;LCDR}hWX^w肷 
	STLM	$12,3			;(R}hݒ) 
	PPO	&HC6			;LCDf[^ݎw
	STL	$28			;1\

	XR	$28,$29			;60H->80H->70H->90H->60H
	XR	$29,&H10		;
#endif

GETPB2:	CAL	XGET			;1M
	JR	Z,GETSUM		;J}/CRMȂ`FbNTmF
	CAL	CHEX1			;ASCII-->BINϊ
	JR	NC,SNERROR
	DIU	$0			;グ
	LD	$16,$0			;
	CAL	RSGET			;1M(J}/CR`FbN)
	CAL	CHEX1			;ASCII-->BINϊ
	JR	NC,SNERROR

	OR	$16,$0			;Mf[^쐬
	ST	$16,($20)		;f[^i[
	ADW	$18,$16			;`FbNTvZ
	ADW	$20,$30,GETPBL		;AhXXV
;
;	get check-sum data
;
GETSUM:	CAL	GETDEC			;`FbNTf[^擾
	SBCW	$18,$10			;`FbNTƍ
	JP	NZ,TMERR		;
	SBCW	$20,$26			;f[^i[I`FbN
	JR	NZ,GETPBF		;
;
;	termination process
;
	CAL	RSCLO			;RS232CN[Y
	LD	$0,&H1A			;EOFR[h
	ST	$0,($20)		;

	PRE	IX,DIRBFR		;
	PRE	IY,DIRBFR + 30		;fBNgf[^]
	PRE	IZ,$24			;
	BUP				;

	PRE	IX,MEMEN		;
	STM	$22,(IX+$31),4		;(MEMEN),(DATDIR) 

	PRE	IX,NOWFL		;J[\𐶐t@Cɍ킹
	STW	$24,(IX+$31)		;
	JP	MENU			;MENUɖ߂

;------------------------------------------------------------
; GETDEC(10iM)
; RS232CoR10iM
; ́F
; óF$10,$11 -- Ml
;       ZF ------- Z:J}/CRM NZ:ʏ핶M
;------------------------------------------------------------
GETDEC:	XRW	$10,$10			;Mf[^
GETDECL:CAL	XGET			;1M($0)
	RTN	Z			;J}/CRMɂďI
	SB	$0,"0"			;0`9ł
	SBC	$0,10			;(9ȏ?)
SNERROR:JP	NC,SNERR		;ERROR
	BIUW	$10			;10{쐬
	LDW	$2,$10			;(2{)
	BIUW	$10			;
	BIUW	$10			;(8{)
	ADW	$10,$2			;(2{+8{)
	LD	$1,$31			;MlJ荞
	ADW	$10,$0,GETDECL		;̕M

;------------------------------------------------------------
; XGET(1M)
; RS232CoR1M
; ́FȂ
; óF$0 --- Ml
;       ZF --- Z:J}/CRM NZ:ʏ핶M
;------------------------------------------------------------
XGET:	CAL	RSGET			;1M
	SBC	$0,&H0A			;LFM͖
	JR	Z,XGET
	SBC	$0,","			;J}MŏI
	RTN	Z
	SBC	$0,&H0D			;CRM`FbN
	RTN
;
;	directory data buffer
;
DIRBFR:	DB	&H00

DIRBF0:	DW	&H0000			;i[JnAhX
	DW	&H0000			;i[IAhX + 1
	DB	&H0D			;BINt@C

DIRBF1:	DB	"        "		;t@Cobt@
DIRBF2:	DB	"   "			;gqobt@
	DB	&HFF,0,0,0,0,0,0,0

DIRBF3:	DW	&H0000			;[h擪AhX
	DW	&H0000			;[hIAhX + 1
	DW	&H0000			;sAhX
;
;	message data
;
MSG01:	DB	12,"loading pbf."
